\ OLPC boot script

: set-command-line  ( -- )
   " "  to boot-file
;

: set-device-name  ( -- )
   " /chosen" find-package  if                       ( phandle )
      " bootpath" rot  get-package-property  0=  if  ( propval$ )
         get-encoded-string                          ( bootpath$ )
         [char] \ left-parse-string  2nip            ( dn$ )
         dn-buf place                                ( )
      then
   then
;

: set-path-name  ( -- )
   alternate?  if
      [ifdef] no-mmp3-gic?  true to no-mmp3-gic?  [then]  \ for android
      " \boot-alt"
   else
      " \boot"
   then
   pn-buf place
;

[ifdef] require-signatures?
   : no-signatures  ( -- )  false to require-signatures?  ;
[else]
   : is-valid  ( $ $ -- true )  4drop true  r> drop  ;
   : is-leased  ( -- )  " run" cn-buf place  ;
   : no-signatures  ( -- )
      ['] is-valid ['] fw-valid?  >body token!
      ['] is-valid ['] sha-valid? >body token!
      ['] false      ['] has-developer-key?  ['] load-from-list    (patch

      ['] is-leased  ['] ?leased             ['] load-from-device  (patch
   ;
[then]

: unlocked-boot
   set-path-name
   set-device-name
   set-command-line
   " ${DN}${PN}\vmlinuz" expand$ 2dup $file-exists? if
      to boot-device
      " ${DN}${PN}\initrd.img" expand$  to ramdisk
      boot
   else
      2drop
      no-signatures
      " last:" load-from-list drop
   then
;

unlocked-boot

\ This script is ignored by locked laptops, because Open Firmware
\ directly verifies signatures of other files in /boot.

\ Source for this script is git repository olpc-kernel path
\ olpc/olpc.fth, and is packaged into kernel rpm for use by
\ olpc-os-builder.

\ To change the kernel command line, ensure laptop is unlocked, run
\ sudo olpc-dev-kernel, and edit the string constant in set-command-line,
\ for example  " debug" to boot-file
